

#!wish.exe

frame .f1 -relief raised -bd 4
frame .f2

pack .f1 -fill x
button .f1.b -text "exit" -relief flat -justify left -command "exit" -padx 0 -pady 0
pack .f1.b -side left

pack .f2 -side top -fill x
label .f2.l -text "circular mouseboard\n\n" -justify left
pack .f2.l -side left

canvas .c -width 320 -height 320
pack .c -side top
set bg [.c cget -bg]

# proc for arrange circular keys
proc ArrangeKeys {start list x1 y1 x2 y2 r} {
    global bg
    
    set lim [expr [llength $list] / 2]
    for {set i 0} {$i < $lim} {incr i} {
	set tmp1 [lindex $list [expr 2 *$i]]
	set tmp2 [lindex $list [expr 2 * $i + 1]]
	.c create arc $x1 $y1 $x2 $y2 -fill $bg -tags $tmp1 -start $start -extent $tmp2
	set theta [expr double([expr $start + $tmp2 / 2]) / 180.0 * 3.14]
	set xt [expr 160 + $r * cos($theta)]
	set yt [expr 160 - $r * sin($theta)]
	.c create text $xt $yt -text "$tmp1" -tags $tmp1
	set start [expr $start + $tmp2]
	.c bind $tmp1 <1> "puts -nonewline $tmp1; flush stdout"
    }
}

#keys

# b c f g m p v w y j k q x z
ArrangeKeys 0 {b 25 c 52 f 40 g 32 m 45 p 32 v 18 w 32 y 30 j 10 k 13 q 11 x 10 z 10} 20 20 300 300 130

# h t s n d l r
ArrangeKeys 0 {h 48 t 78 s 45 n 60 d 38 l 38 r 53} 40 40 280 280 110

# e a i o u
ArrangeKeys -60 {e 120 a 75 i 70 o 70 u 25} 60 60 260 260 80

# space
.c create oval 100 100 220 220 -fill $bg -tags {space}
.c create text 160 160 -text "space" -tags {space}
.c bind space <1> {puts -nonewline " "; flush stdout}
