#!/usr/local/bin/wish

set font [lsearch $argv "-font"]
if { $font != -1 } {
    set font [lindex $argv [ expr 1 + $font]]
}

frame .f1 -relief raised -bd 4
frame .f2

pack .f1 -fill x
button .f1.b -text "exit" -relief flat -justify left -command "exit" -padx 0 -pady 0
if { $font != -1 } { .f1.b config -font $font }
pack .f1.b -side left

pack .f2 -side top -fill x
label .f2.l -text "alphabetic mouseboard\n\n" -justify left
if { $font != -1 } { .f2.l config -font $font }
pack .f2.l -side left

frame .abcd
frame .klmn
frame .tuvw
frame .space

pack .abcd .klmn .tuvw .space -side top

button .space.space -text "Space" -command { puts -nonewline " "; flush stdout }
set bg [.space.space cget -background]
.space.space config -activebackground $bg -width 12
if { $font != -1 } { .space.space config -font $font }
pack .space.space

foreach i { p y f g c r l } {
    button .abcd.$i -text "$i" -command "puts -nonewline $i; flush stdout" -activebackground $bg -padx 0 -width 2
    if { $font != -1 } { .abcd.$i config -font $font}
    pack .abcd.$i -side left
}

foreach i { a o e u i d h t n s } {
    button .klmn.$i -text "$i" -command "puts -nonewline $i; flush stdout" -activebackground $bg -padx 0 -width 2
    if { $font != -1 } { .klmn.$i config -font $font}
    pack .klmn.$i -side left
}

foreach i { q j k x b m w v z } {
    button .tuvw.$i -text "$i" -command "puts -nonewline $i; flush stdout" -activebackground $bg -padx 0 -width 2
    if { $font != -1 } { .tuvw.$i config -font $font}
    pack .tuvw.$i -side left
}
